use std::fs::File;
use std::io::{Write, BufReader, BufRead, Error};
use chrono;
use std::time::Instant;

const PUBLISH_PATH: &str = "./pub/";
const TEMPLATE_PATH: &str = "./src/templates/";

fn render_html(file: &str, template_file: &str) {
    let output_path = &format!("{}{}", PUBLISH_PATH, file);
    let template_path = &format!("{}{}", TEMPLATE_PATH, template_file);

    let now = Instant::now();
    // TODO: Generate HTML with template and data
    let html_string = "<h1>Hello!</h1>";

    let output = format!(
        "{}\n\n<!--\n  {}\n  {}\n  generated in {:.2?}\n-->",
        html_string,
        template_path,
        chrono::offset::Local::now(),
        now.elapsed(),
    );

    let result = write_file(output_path, output);
    match result {
        Ok(file) => file,
        Err(e) => panic!("Problem creating {:?}", e)
    }

    /*
    let input = File::open(output_path)?;
    let buffered = BufReader::new(input);

    for line in buffered.lines() {
        println!("{}", line?);
    }
    */

}

fn write_file(file_path: &str, contents: String) -> Result<(), Error> {
    let mut output_file = File::create(file_path)?;
    write!(output_file, "{}", contents)?;
    Ok(())
}

fn main() {

    render_html("index.html", "index.tmpl");

}
